﻿#include "pch.h"
#include "MainPage.xaml.h"

using namespace SenseHat_Sensors_CppCx;
using namespace Platform;
using namespace Windows::UI::Core;
using namespace SenseHat::Sensors::TelemetryControl;

MainPage::MainPage()
{
	InitializeComponent();	

	telemetry->DataReady += ref new DataReadyEventHandler(this, &MainPage::OnDataReady);
}

void MainPage::OnDataReady(Object^ sender, TelemetryEventArgs^ e)
{
	if (Dispatcher->HasThreadAccess)
	{
		ViewModel->Temperature = e->Temperature;
	}
	else
	{
		Dispatcher->RunAsync(CoreDispatcherPriority::Normal, ref new DispatchedHandler([=]()
		{
			MainPage::OnDataReady(sender, e);
		}));
	}
}

void MainPage::ButtonStartSensorReading_Click(Object^ sender, RoutedEventArgs^ e)
{
	telemetry->Start();
	ViewModel->IsTelemetryActive = telemetry->IsActive;
}

void MainPage::ButtonStopSensorReading_Click(Object^ sender, RoutedEventArgs^ e)
{
	telemetry->Stop();
	ViewModel->IsTelemetryActive = telemetry->IsActive;
}
