﻿using ArgumentValidation;
using System;
using System.Threading.Tasks;
using Windows.ApplicationModel;
using Windows.Storage.Streams;

namespace FrequencyDistribution
{
    public static class StorageFileHelper
    {
        public static async Task<IRandomAccessStreamWithContentType> OpenLocalFile(string fileName)
        {
            Check.IsNull(fileName);

            // Get app folder
            var storageFolder = Package.Current.InstalledLocation;

            // Get and open file
            var storageFile = await storageFolder.GetFileAsync(fileName);

            return await storageFile.OpenReadAsync();
        }

        public static async Task<Windows.Storage.Streams.Buffer> StreamToBuffer(
            IRandomAccessStreamWithContentType stream)
        {
            Check.IsNull(stream);

            var size = Convert.ToUInt32(stream.Size);

            var buffer = new Windows.Storage.Streams.Buffer(size);

            await stream.ReadAsync(buffer, size, InputStreamOptions.None);

            return buffer;
        }
    }
}
