﻿namespace AnomalyDetection.PredictiveClient
{
    public class TemperatureInput
    {
        public string[] ColumnNames { get; set; }
        public string[,] Values { get; set; }
    }

    public class Inputs
    {
        public TemperatureInput TemperatureInput { get; set; }
    }

    public class GlobalParameters { }

    public class PredictionRequest
    {
        public Inputs Inputs { get; set; }
        public GlobalParameters GlobalParameters { get; set; }

        public PredictionRequest(double temperature)
        {
            Inputs = new Inputs()
            {
                TemperatureInput = new TemperatureInput()
                {
                    ColumnNames = new string[]
                    {
                        "Temperature"
                    },

                    Values = new string[,]
                    {
                        { temperature.ToString() },
                        { "0" },
                    }
                }
            };
        }
    }
}
