﻿using Microsoft.ServiceBus.Messaging;
using Newtonsoft.Json;
using SenseHat.Portable.Helpers;
using System;
using System.Text;

namespace CustomIoTSolution.EventProcessor.Models
{
    public class TemperatureEventData
    {
        [JsonProperty(PropertyName = "avgtemperature")]
        public float AverageValue { get; set; }

        public string DeviceId { get; set; }

        public static TemperatureEventData FromEventData(EventData eventData)
        {
            Check.IsNull(eventData);

            TemperatureEventData result = null;

            try
            {
                var jsonString = Encoding.UTF8.GetString(eventData.GetBytes());

                result = JsonConvert.DeserializeObject<TemperatureEventData>(jsonString);
            }
            catch (Exception) { }

            return result;
        }
    }
}
